/*
 * The contents of this file are subject to the terms 
 * of the Common Development and Distribution License 
 * (the License).  You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the license at 
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing 
 * permissions and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL 
 * Header Notice in each file and include the License file 
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.  
 * If applicable, add the following below the CDDL Header, 
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information: 
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Copyright 2006 Sun Microsystems, Inc. All rights reserved.
 */
 
/*
 * $Header: /cvs/glassfish/admin/mbeans/src/java/com/sun/enterprise/admin/dottedname/DottedNameAliasSupport.java,v 1.3 2005/12/25 03:42:02 tcfujii Exp $
 * $Revision: 1.3 $
 * $Date: 2005/12/25 03:42:02 $
 */
package com.sun.enterprise.admin.dottedname;

import java.util.Set;
import java.util.HashSet;

import com.sun.enterprise.admin.util.ArrayConversion;


public class DottedNameAliasSupport
{
	public DottedNameAliasSupport( )
	{

	}


	public final static String	DOMAIN_SCOPE		= "domain";
	public final static String	DOMAIN_SCOPE_DOT	= DOMAIN_SCOPE + ".";
	
	
		static public boolean
	scopeIsDomain( String scope )
	{
		return( scope.equals( DOMAIN_SCOPE ) || scope.startsWith( DOMAIN_SCOPE_DOT ) );
	}
	 
	
	
	/*
		Names which are domain.xxx names which are aliased into server
	 */
	static public final Set	DOMAIN_PARTS	= ArrayConversion.toSet( new String []
		{
			// these are prefixes
			"applications",
			"resources"
		} );
		
		public static boolean
	isAliasedDomain( final DottedName dn )
	{
		boolean	isAliased	= false;
		
		final java.util.List	parts	= dn.getParts();
		
		if ( parts.size() >= 1 )
		{
			isAliased	= DOMAIN_PARTS.contains( parts.get( 0 ) );
		}
		
		return( isAliased );
	}
	
	
	
	/*
		Names following the server name which indicate that the server name is *not* to
		be aliased into config.
	 */
	static private final Set	NON_ALIASED_PARTS_SET	= ArrayConversion.toSet( new String []
		{
			// these are prefixes
			"application-ref",
			"resource-ref",
			"config-ref",
			"node-agent-ref",
			"server-ref",
			
			// these are attributes
			"property",
			"name"
		} );
	
		protected static boolean
	isNonAliasedServer( final DottedName dn )
	{
		boolean	isNonAliased	= false;
		
		final java.util.List	parts	= dn.getParts();
		
		if ( parts.size() >= 1 )
		{
			isNonAliased	= NON_ALIASED_PARTS_SET.contains( parts.get( 0 ) );
		}
		
		return( isNonAliased );
	}
	
	/*
		Map any aliased scope names into their true dotted names.
		
		Here 'server' is the name of a server.
		
		Rules:
			server.* 	=> config.*  (except for NON_ALIASED_PARTS_SET)
			*	 => same as input
	 */
		public static String
	resolveScope( final DottedNameServerInfo serverInfo, final DottedName dn )
		throws DottedNameServerInfo.UnavailableException
	{
		final String	scopeNameIn		= dn.getScope();
		String			actualScopeName	= scopeNameIn;
		
		if ( scopeIsDomain( scopeNameIn ) )
		{
			// no change required
		}
		else
		{
			final boolean	scopeIsServerName	= serverInfo.getServerNames().contains( actualScopeName );

			if ( scopeIsServerName )
			{
				if ( isAliasedDomain( dn ) )
				{
					actualScopeName	= DottedNameAliasSupport.DOMAIN_SCOPE;
				}
				else if ( isNonAliasedServer( dn ) )
				{
					// no change
				}
				else
				{
					// it's a server name, and it *is* aliased, but wasn't alised into domain
					// so it must be aliased into a config
					actualScopeName	= serverInfo.getConfigNameForServer( scopeNameIn );
				}
			}
		}
		
		return( actualScopeName );
	}
	
	

	
	static java.util.logging.Logger		sLogger	= null;
		static void
	dm( Object o )
	{
		if (sLogger == null )
		{
        	sLogger	= java.util.logging.Logger.getLogger( "DottedNameGetSetMBeanImplLogger" );
        	sLogger.setLevel( java.util.logging.Level.INFO );
        }
        
        sLogger.info( o.toString() );
	}
}




